/* tslint:disable */
/* eslint-disable */
/**
* @param {Float64Array} a
* @param {Float64Array} b
* @returns {Float64Array}
*/
export function subtract_matrix(a: Float64Array, b: Float64Array): Float64Array;
/**
* @param {Float64Array} a
* @param {number} b
* @returns {Float64Array}
*/
export function subtract_scalar(a: Float64Array, b: number): Float64Array;
/**
* @param {Float64Array} a
* @param {Float64Array} b
* @returns {Float64Array}
*/
export function add_matrix(a: Float64Array, b: Float64Array): Float64Array;
/**
* @param {Float64Array} a
* @param {number} b
* @returns {Float64Array}
*/
export function add_scalar(a: Float64Array, b: number): Float64Array;
/**
* @param {Float64Array} a
* @param {Float64Array} b
* @param {number} rows
* @param {number} m
* @param {number} n
* @returns {Float64Array}
*/
export function multiply(a: Float64Array, b: Float64Array, rows: number, m: number, n: number): Float64Array;
/**
* @param {Float64Array} a
* @param {Float64Array} b
* @returns {Float64Array}
*/
export function dot_matrix(a: Float64Array, b: Float64Array): Float64Array;
/**
* @param {Float64Array} a
* @param {number} b
* @returns {Float64Array}
*/
export function dot_scalar(a: Float64Array, b: number): Float64Array;
/**
* @param {Float64Array} a
* @param {number} rows
* @param {number} columns
* @returns {Float64Array}
*/
export function transpose(a: Float64Array, rows: number, columns: number): Float64Array;
/**
* @param {Float64Array} a
* @returns {number}
*/
export function sum(a: Float64Array): number;
/**
* @param {Float64Array} a
* @returns {number | undefined}
*/
export function argmax(a: Float64Array): number | undefined;

export type InitInput = RequestInfo | URL | Response | BufferSource | WebAssembly.Module;

export interface InitOutput {
  readonly memory: WebAssembly.Memory;
  readonly subtract_matrix: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly subtract_scalar: (a: number, b: number, c: number, d: number) => void;
  readonly add_matrix: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly add_scalar: (a: number, b: number, c: number, d: number) => void;
  readonly multiply: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number) => void;
  readonly dot_matrix: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly dot_scalar: (a: number, b: number, c: number, d: number) => void;
  readonly transpose: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly sum: (a: number, b: number) => number;
  readonly argmax: (a: number, b: number, c: number) => void;
  readonly __wbindgen_add_to_stack_pointer: (a: number) => number;
  readonly __wbindgen_malloc: (a: number) => number;
  readonly __wbindgen_free: (a: number, b: number) => void;
}

export type SyncInitInput = BufferSource | WebAssembly.Module;
/**
* Instantiates the given `module`, which can either be bytes or
* a precompiled `WebAssembly.Module`.
*
* @param {SyncInitInput} module
*
* @returns {InitOutput}
*/
export function initSync(module: SyncInitInput): InitOutput;

/**
* If `module_or_path` is {RequestInfo} or {URL}, makes a request and
* for everything else, calls `WebAssembly.instantiate` directly.
*
* @param {InitInput | Promise<InitInput>} module_or_path
*
* @returns {Promise<InitOutput>}
*/
export default function init (module_or_path?: InitInput | Promise<InitInput>): Promise<InitOutput>;
